package com.zsc.edu.dify.modules.dify.controller;

import io.github.guoshiqiufeng.dify.core.pojo.DifyPageResult;
import io.github.guoshiqiufeng.dify.dataset.DifyDataset;
import io.github.guoshiqiufeng.dify.dataset.dto.request.*;
import io.github.guoshiqiufeng.dify.dataset.dto.response.*;
import jakarta.annotation.Resource;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("/v1/dataset")
public class V1DatasetController {
    @Resource
    private DifyDataset difyDataset;

    /**
     * 分页查询知识库
     *
     * @param request
     * @return
     */
    @GetMapping("/page")
    public DifyPageResult<DatasetResponse> page(@RequestBody DatasetPageRequest request){
        return difyDataset.page(request);
    }

    /**
     * 通过文件创建文档
     *
     * @param request
     * @return
     */
    @GetMapping("/createDocumentByFile")
    public DocumentCreateResponse createDocumentByFile(@RequestBody DocumentCreateByFileRequest request){
        return difyDataset.createDocumentByFile(request);
    }

    /**
     * 分页查询文档
     *
     * @param request
     * @return
     */
    @GetMapping("/pageDocument")
    public DifyPageResult<DocumentInfo> pageDocument(@RequestBody DatasetPageDocumentRequest request){
        return difyDataset.pageDocument(request);
    }

    /**
     * 获取上传文件信息
     *
     * @param datasetId
     * @param documentId
     * @return
     */
    @PostMapping("/uploadFileInfo")
    public UploadFileInfoResponse uploadFileInfo(String datasetId, String documentId){
        return difyDataset.uploadFileInfo(datasetId, documentId,"app-mM2UGTE5QVPLCwGvwifnV0g7");
    }

    /**
     * 删除文档
     *
     * @param datasetId
     * @param documentId
     * @return
     */
    @DeleteMapping("/deleteDocument")
    public DocumentDeleteResponse deleteDocument(String datasetId, String documentId){
        return difyDataset.deleteDocument(datasetId, documentId, "app-mM2UGTE5QVPLCwGvwifnV0g7");
    }

    /**
     * 创建分段
     *
     * @param request
     * @return
     */
    @PostMapping("/createSegment")
    public SegmentResponse createSegment(@RequestBody SegmentCreateRequest request){
        return difyDataset.createSegment(request);
    }

    /**
     * 创建子分段
     *
     * @param request
     * @return
     */
    @PostMapping("/createSegmentChildChunk")
    public SegmentChildChunkCreateResponse createSegmentChildChunk(@RequestBody SegmentChildChunkCreateRequest request){
        return difyDataset.createSegmentChildChunk(request);
    }

    /**
     * 检索
     *
     * @param request
     * @return
     */
    @GetMapping("/retrieve")
    public RetrieveResponse retrieve(@RequestBody RetrieveRequest request){
        return difyDataset.retrieve(request);
    }
}
