package com.zsc.edu.dify.modules.dify.service.Impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zsc.edu.dify.modules.dify.entity.AppsResponse;
import com.zsc.edu.dify.modules.dify.mapper.AppsResponseMapper;
import com.zsc.edu.dify.modules.dify.repo.AppsResponseRepository;
import com.zsc.edu.dify.modules.dify.service.DifyServerService;
import io.github.guoshiqiufeng.dify.server.DifyServer;
import io.github.guoshiqiufeng.dify.server.dto.response.AppsResponseVO;
import jakarta.annotation.Resource;
import lombok.AllArgsConstructor;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @author zhuang
 */
@AllArgsConstructor
@Service
public class DifyServerServiceImpl extends ServiceImpl<AppsResponseRepository, AppsResponse> implements DifyServerService {
    @Resource
    private AppsResponseMapper appsResponseMapper;
    @Resource
    private DifyServer difyServer;

    @Override
    public List<AppsResponseVO> getApps(String mode, String name) {
        return addApps(difyServer.apps(mode, name));
    }

    public List<AppsResponseVO> addApps(List<AppsResponseVO> appsResponseList) {
        for(AppsResponseVO appsResponse : appsResponseList){
            boolean isHave = baseMapper.exists(new QueryWrapper<AppsResponse>().eq("id", appsResponse.getId()));
            if(!isHave){
                baseMapper.insert(appsResponseMapper.toEntity(appsResponse));
            }else{
                baseMapper.updateById(appsResponseMapper.toEntity(appsResponse));
            }

        }
        return appsResponseList;
    }
}
